#2011 Chaoborus production calculation using Plante and Downing 1989
#modified 24 Jan 2013 - USED NET EFFICIENCIES
#P Kelly

setwd('~/Documents/Notre Dame/Katie Baglini data spring 2011/R data')

#load count and length data
chaobCount=read.csv("2011ChaoborusCounts.csv")
chaobLength=read.csv("Chaoborus lengths.csv")

#calculate counts per square meter
uniqueID=paste(chaobCount$lake,chaobCount$date,sep="")
chaobCount$uniqueID=uniqueID
uniqueID=paste(chaobLength$Lake,chaobLength$Date,sep="")
chaobLength$uniqueID=uniqueID
chaobCount=chaobCount[-c(13,26),]
countsPerM2=((chaobCount$chaoborus_count/2)/0.07297)/0.25
chaobCount$countsPerM2=countsPerM2

biomass=1.189*log(pi*((chaobLength$width*10^3)/2)^2*(chaobLength$bodyLength*10^3),10)-8.644
biomass=10^(biomass)
chaobLength$biomass_ug=biomass
mean.biomass=tapply(chaobLength$biomass_ug,chaobLength$uniqueID,mean,na.rm=TRUE)
chaobCount$mean.biomass_ug=mean.biomass

#calculate annual biomass (counts per square meter * mean biomass)
annualBiomass=chaobCount$countsPerM2*chaobCount$mean.biomass_ug
chaobCount$annualBiomass_g=annualBiomass*10^-6

write.csv(chaobCount,file='chaoborusCounts_wBiomass.csv')

#add julian day to counts
Jday=strptime(chaobCount$date, "%m/%d/%Y")$yday+1
chaobCount$Jdate=Jday

#find maximum biomass of chaoborus per sample
maxBiomass=tapply(chaobLength$biomass,chaobLength$uniqueID,max,na.rm=TRUE)
chaobCount$maxBodyMass=maxBiomass

ELmean.biomass=mean(chaobCount$annualBiomass[chaobCount$lake=="EL"])
WLmean.biomass=mean(chaobCount$annualBiomass[chaobCount$lake=="WL"])
ELmax.biomass=mean(chaobCount$maxBodyMass[chaobCount$lake=="EL"])
WLmax.biomass=mean(chaobCount$maxBodyMass[chaobCount$lake=="WL"],na.rm=TRUE)

ELtemp=getTemp(tempData,"EL")
WLtemp=getTemp(tempData,"WL")

ELlogP=0.06+(0.79*log(ELmean.biomass))-(0.16*log(ELmax.biomass))+(0.05*ELtemp)
ELchaobProd=log(ELlogP)

WLlogP=0.06+(0.79*log(WLmean.biomass))-(0.16*log(WLmax.biomass))+(0.05*WLtemp)
WLchaobProd=log(WLlogP)