#####for use with Katies summer 2011 zoop dataset
#####NAs need to be removed for this to work

counts=read.csv("ZoopCountAverages2011.csv")
lengths=read.csv("ZoopLengths2011.csv")
LWregressions=read.csv("LWregressions2.csv")

uniqueID=paste(lengths$lake,lengths$date,lengths$taxa,sep="")
lengths$uniqueID=uniqueID
uniqueID=paste(counts$lake,counts$date,counts$taxa,sep="")
counts$uniqueID=uniqueID


mass=c()
for(i in 1:nrow(lengths)){
	rowi=match(lengths$taxa[i],LWregressions$taxa)
	mass[i]=exp(LWregressions$b[rowi]+(LWregressions$m[rowi]*(log(lengths$length[i]))))
	}
lengths$mass=mass

counts=counts[order(counts$uniqueID),]
lengths=lengths[order(lengths$uniqueID),]
mean.taxa=with(lengths,tapply(lengths$mass,lengths$uniqueID,mean,na.rm=TRUE))
uniqueID=unique(lengths$uniqueID)
avgBiomass=data.frame(uniqueID,mean.taxa)

countsPerM2=((counts$counts/0.25)/0.07297)/2
counts$countsPerM2=countsPerM2

annualBiomass=c()
for(i in 1:nrow(counts)){
	rowi=match(counts$uniqueID[i],avgBiomass$uniqueID)
	annualBiomass[i]=avgBiomass$mean.taxa[rowi]*counts$countsPerM2[i]
	}
counts$annualBiomass=annualBiomass

annualBiomassSD=c()
for(i in 1:nrow(counts)){
	rowi=match(counts$uniqueID[i],avgBiomass$uniqueID)
	annualBiomassSD[i]=avgBiomass$mean.taxa[rowi]*counts$SD[i]
	}
counts$annualBiomassSD=annualBiomassSD

Parameters=function(lengths,counts,lake){
lakelengths=lengths[lengths[,1]==lake,]
lakecounts=counts[counts[,1]==lake,]
annualBiomass=lakecounts$annualBiomass/10^6
lakecounts$annualBiomass=annualBiomass
annualBiomassSD=((((lakecounts$annualBiomassSD)/2)/(0.07297))/10^6)
lakecounts$annualBiomassSD=annualBiomassSD
lakecounts=lakecounts[!is.na(lakecounts$annualBiomass),]
lakelengths=lakelengths[!is.na(lakelengths$mass),]
taxaAnnualBiomass=with(lakecounts,tapply(lakecounts$annualBiomass,lakecounts$taxa,mean))
taxaAnnualBiomassSD=with(lakecounts,tapply(lakecounts$annualBiomassSD,lakecounts$taxa,sum))
maxBodyMass=with(lakelengths,tapply(lakelengths$mass,lakelengths$taxa,max))
maxBodyMass=maxBodyMass/10^3
seasonalSD=tapply(lakecounts$annualBiomass,lakecounts$taxa,sd)
x=data.frame(taxaAnnualBiomass,maxBodyMass,taxaAnnualBiomassSD,seasonalSD)
return(x)
}

tempData=read.csv("2011Limnodata.csv",header=TRUE)
getTemp=function(tempData,lake){
lakeTemps=tempData[tempData[,1]==lake,]
temps=lakeTemps$Temp_degreesC[lakeTemps$Depth==0.0]
temp=mean(temps)
return(temp)
}

Production=function(lakeparms,laketemp)
{
logP=0.06+(0.79*log(lakeparms$taxaAnnualBiomass,10))-(0.16*log(lakeparms$maxBodyMass,10))+(0.05*laketemp)
P=10^logP
logSD=0.06+(0.79*log(lakeparms$taxaAnnualBiomassSD,10))-(0.16*log(lakeparms$maxBodyMass,10))+(0.05*laketemp)
SD=10^logSD
logseasonalSD=0.06+(0.79*log(lakeparms$seasonalSD,10))-(0.16*log(lakeparms$maxBodyMass,10))+(0.05*laketemp)
seasonalSD=10^logseasonalSD
P=data.frame(P,SD,seasonalSD)
return(P)
}


EL=Parameters(lengths,counts,"EL")
ELtemp=getTemp(tempData,"EL")
kEL=Production(EL,ELtemp)
WL=Parameters(lengths,counts,"WL")
WLtemp=getTemp(tempData,"WL")
kWL=Production(WL,WLtemp)

sumEL=sum(kEL$P)
sumWL=sum(kWL$P)

counts[1,]
counts=counts[-16,]
countsPerM2=((counts$counts/2)/0.07297)
counts$countsPerM2=countsPerM2
avgMass=tapply(lengths$mass,lengths$uniqueID,mean, na.rm=TRUE)
length(avgMass)
counts$avgMass=avgMass
counts[1,]
biomassPerM2=counts$avgMass*counts$countsPerM2
counts$biomassPerM2=biomassPerM2
counts$uniqueID